var cert_loading_over = false;
var cont_loading_over = false;
var g_conts = new Array();
var g_conts_counter = 0;
var g_certenum_guid = 0;
var activeTabName;
var g_selected_cert_index = -1;

var elemStoreLoc = document.getElementById(idSelectStoreLocation);
if (elemStoreLoc)
    elemStoreLoc.onchange = onStoreSelected;
var elemStoreName = document.getElementById(idSelectStoreName);
if (elemStoreName)
    elemStoreName.onchange = onStoreSelected;
var openFileContent;

function isAndroid() {
    return navigator.userAgent.match(/Android/i);
}

function uuidv4() {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'
    .replace(/[xy]/g, function (c) {
        const r = Math.random() * 16 | 0, 
            v = c == 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(16);
    });
}

function toggle_div_inner(isShow, elementId, skipElements) {
    const div = document.getElementById(elementId);
    const childElements = div.querySelectorAll('*');

    childElements.forEach(element => {
        if (skipElements && skipElements.includes(element.id))
            return;
        if (isShow)
            element.style.display = '';
        else
            element.style.display = 'none';
    });
}

function show_div_inner(elementId, skipElements) {
    toggle_div_inner(true, elementId, skipElements);
}

function hide_div_inner(elementId) {
    toggle_div_inner(false, elementId);
}

function toggleNoContMessage() {
    var b = document.getElementById(idBoxNoCont);
    var c = document.getElementById(idUlContainer);
    var s = document.getElementById(idSearchBarContainer);
    if (b && c) {
        if (!cont_loading_over) {
            b.style.display = "none";
            c.style.display = "block";
            s.style.display = "block";
            return;
        }
        if (g_conts.length == 0) {
            b.style.display = "flex";
            c.style.display = "none";
            s.style.display = "none";
        }
        else {
            b.style.display = "none";
            c.style.display = "block";
            s.style.display = "block";
        }
    }
}

function toggleCheckbox(id) {
    const checkbox = document.getElementById(id);
    checkbox.checked = !checkbox.checked;
}

function toggleNoCertMessage() {
    var b = document.getElementById(idBoxNoCert);
    var c = document.getElementById(idUlCertificate);
    var s = document.getElementById(idSearchBarCertificate);
    if (b && c && s) {
        if (!cert_loading_over) {
            b.style.display = "none";
            c.style.display = "none";
            s.style.display = "block";
            return;
        }
        if (global_selectbox_container.length == 0) {
            b.style.display = "flex";
            c.style.display = "none";
            s.style.display = "none";
        }
        else {
            b.style.display = "none";
            c.style.display = "block";
            s.style.display = "block";
        }
    }
}

function toggleContInfo() {
    var s = document.getElementById(idContListBox)
    if (s) {
        var selectIndex = s.selectedIndex;
    }
    var e = document.getElementById(idContInfo);
    if (e && selectIndex != -1) {
        e.style.display = '';
    } else {
        e.style.display = 'none';
    }
}

function toggleCertInfo() {
    var selectIndex = g_selected_cert_index;
    var e = document.getElementById(idCertInfo);
    if (e && selectIndex != -1) {
        e.style.display = '';
    } else {
        e.style.display = 'none';
    }
    var e = document.getElementById(idCertChainInfo);
    if (e && selectIndex != -1) {
        e.style.display = '';
    } else {
        e.style.display = 'none';
    }
}

function toggleFilteredOutCertificates() {
    var s = document.getElementById(idUlCertificate);
    if (!s) {
        return;
    }
    var lis = s.children;
    for (var i = 0; i < lis.length; i++) {
        var oLi = lis[i];
        var filteredOutValue = oLi.getAttribute(filteredOutAttribute);
        if (filteredOutValue && parseInt(oLi.getAttribute(filteredOutAttribute)) != 0)
            oLi.style.display = "none";
    }
}

function highlightTab(btnid) {
    const buttons = document.querySelectorAll('.nav-button-active');
    buttons.forEach(button => {
        button.classList.remove('nav-button-active');
    });
    document.getElementById(btnid).classList.add('nav-button-active');
}

function showGeneralInfoTab() {
    highlightTab(idNavBtnGeneral);
    show_div_inner(idGeneralInformationTab);
    hide_div_inner(idContainersTab);
    hide_div_inner(idCertificatesTab);
    hide_div_inner(idBasicCertificatesTab);
    activeTabName = nameTabGeneral;
}

function showContainersTab() {
    highlightTab(idNavBtnConts);
    hide_div_inner(idGeneralInformationTab);
    show_div_inner(idContainersTab, [idBoxNoCont, idContInfo]);
    hide_div_inner(idCertificatesTab);
    hide_div_inner(idBasicCertificatesTab);
    toggleContInfo();
    toggleNoContMessage();
    toggleContButtons();
    activeTabName = idContainersTab;
}

function showCertificatesTab() {
    highlightTab(idNavBtnCerts);
    hide_div_inner(idGeneralInformationTab);
    hide_div_inner(idContainersTab);
    show_div_inner(idCertificatesTab, [idBoxNoCert, idCertInfo, idCertChainInfo]);
    hide_div_inner(idBasicCertificatesTab);
    toggleFilteredOutCertificates();
    toggleCertInfo();
    toggleNoCertMessage();
    toggleCertButtons();
    activeTabName = idCertificatesTab;
}

function showBasicCertificatesTab() {
    highlightTab(idNavBtnBasicCerts);
    hide_div_inner(idGeneralInformationTab);
    hide_div_inner(idContainersTab, [idBoxNoCont, idContInfo]);
    hide_div_inner(idCertificatesTab);
    fillBasicCertificates_Async();
    show_div_inner(idBasicCertificatesTab);
    activeTabName = idBasicCertificatesTab;
}

function showContent() {
    document.getElementById(idContent).style.display = '';
}

function showInfoMsg(msg) {
    alert(msg);
}

function showErrorMsg(msg) {
    msg = cadesplugin.getLastError(msg);
    alert(msg);
}

function removeOptions(selectElement) {
    var i, L = selectElement.options.length - 1;
    for (i = L; i >= 0; i--) {
        selectElement.remove(i);
    }
}

function enableElem(elemId, toEnable) {
    var el = document.getElementById(elemId);
    if (el && toEnable)
        el.disabled = false;
    if (el && !toEnable)
        el.disabled = true;
}

function isCertificateSelected() {
    if (g_selected_cert_index != -1)
        return true;
    return false;
}

function isContainerSelected() {
    var s = document.getElementById(idContListBox)
    if (s && s.selectedIndex != -1)
        return true;
    return false;
}

var isCertInCont = false;
function isCertificateInCont() {
    // Можно сделать лучше
    return isCertInCont;
}

function isCertificateDeletable() {
    if (elemStoreLoc.value == cadesplugin.CADESCOM_CONTAINER_STORE ||
        elemStoreLoc.value == cadesplugin.CADESCOM_SMART_CARD_USER_STORE) {
        return false;
    }
    else return true;
}

function isStoreNameAvailable() {
    if (elemStoreLoc.value == cadesplugin.CADESCOM_CONTAINER_STORE ||
        elemStoreLoc.value == cadesplugin.CADESCOM_SMART_CARD_USER_STORE)
        return false;
    return true;

}
function toggleContButtons() {
    if (isContainerSelected()) {
        enableElem(idBtnContInstallCert, isCertificateInCont());
        enableElem(idBtnContDelete, true);
    }
    else {
        enableElem(idBtnContInstallCert, false);
        enableElem(idBtnContDelete, false);
    }
}

function toggleCertButtons() {
    if (isCertificateSelected()) {
        enableElem(idBtnCertExportCer, true);
        if (isCertificateDeletable()) 
            enableElem(idBtnCertDelete, true);
        else
            enableElem(idBtnCertDelete, false);
        // enableElem(idBtnCertArchive, true);
    }
    else {
        enableElem(idBtnCertExportCer, false);
        enableElem(idBtnCertDelete, false);
        // enableElem(idBtnCertArchive, false);
    }
}

function applyOnClickPin() {
    var apply = document.getElementById(idApplyBtnPin);
    apply.disabled = true;
    cadesplugin.async_spawn(function* (args) {
        var pinField = document.getElementById(idModalInfoPin);
        try {
            var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
            var pin = pinField.value;
            yield oStore.ImportPFX(openFileContent, pin);
            var oCertificates = yield oStore.Certificates
            var cCount = yield oCertificates.Count;
            for (var i = 1; i <= cCount; i++) {
                var oCert = yield oCertificates.Item(i);
                InstallSingleCert(oCert);
            }
            yield oStore.Close();
            openFileContent = null;
            document.getElementById(idModalSuccessPin).style.display = "";
            document.getElementById(idModalErrorPin).style.display = "none";
            refreshLists();
            closePinPopup();
        }
        catch (err) {
            document.getElementById(idModalSuccessPin).style.display = "none";
            var modalError = document.getElementById(idModalErrorPin);
            modalError.innerHTML = cadesplugin.getLastError(err);
            modalError.style.display = "";
            pinField.focus();
        }
        pinField.value = "";
        apply.disabled = false;
    }, event.target);
}

function closePinPopup() {
    document.getElementById(idModalInfoPin).value = "";
    var mpopup = document.getElementById(idMpopupPin);
    mpopup.style.display = "none";
}

function showPinPopUp() {
    var mpopup = document.getElementById(idMpopupPin);
    var close = document.getElementById(idModalClosePin);
    var cancel = document.getElementById(idCancelBtnPin);
    var apply = document.getElementById(idApplyBtnPin);
    var pinField = document.getElementById(idModalInfoPin);
    document.getElementById(idModalSuccessPin).style.display = "none";
    document.getElementById(idModalErrorPin).style.display = "none";
    mpopup.style.display = "block";
    close.onclick = function () {
        closePinPopup()
    };
    cancel.onclick = function () {
        closePinPopup()
    };
    window.addEventListener("click", function (event) {
        if (event.target == mpopup) {
            closePinPopup();
        }
    });
    apply.onclick = applyOnClickPin;
    pinField.focus();
}

function resetGlobalContList() {
    resetUIList(idContListBox, idUlContainer, idSearchBarContainer);
    removeOptions(document.getElementById(idContListBox));
    g_conts = new Array();
    g_conts_counter = 0;
}

function resetGlobalCertList() {
    resetUIList(idCertListBox, idUlCertificate, idSearchBarCertificate);
    removeOptions(document.getElementById(idCertListBox));
    global_selectbox_container = new Array();
    global_isFromCont = new Array();
    global_selectbox_counter = 0;
    g_selected_cert_index = -1;
}

function onStoreSelected(event) {
    resetGlobalCertList();
    var elemStoreLoc2 = document.getElementById(idBtnDropdownStoreName);
    if (isStoreNameAvailable()) {
        elemStoreName.disabled = false;
        elemStoreLoc2.disabled = false;
    }
    else {
        elemStoreName.disabled = true;
        elemStoreLoc2.disabled = true;
    }
    refreshLists({ cert: true });
}

function onImportPFX() {
    document.getElementById(idButton_import_pfx).click();
}

function onImportQR() {
    if (!isAndroid()) {
        if (window.confirm('QR-сканер доступен в КриптоПро Fox для Android.\nПерейти на страницу загрузки?')) {
            window.location.href = 'https://www.cryptopro.ru/forum2/default.aspx?g=posts&t=23464';
        };
        return;
    }
    cadesplugin.async_spawn(function* (args) {
        try {
            var oAbout = yield cadesplugin.CreateObjectAsync("CAdESCOM.about");
            var verMajor = yield oAbout.MajorVersion;
            var verMinor = yield oAbout.MinorVersion;
            var verBuild = yield oAbout.BuildVersion;
            if (verMajor < 2 || verMajor == 2 && verMinor == 0 && verBuild < 15271) {
                if (window.confirm('Для использования QR-сканера требуется версия КриптоПро ЭЦП Браузер plug-in не ниже 2.0.15271.\nПерейти на страницу загрузки?')) {
                    window.location.href = 'https://www.cryptopro.ru/forum2/default.aspx?g=posts&t=23464';
                };
            }
            window.postMessage("LAUNCH_QR_SCANNER", "*");
        }
        catch (err) {
            showErrorMsg(err);
        }
    });
}

function onInstallCert() {
    document.getElementById(idButton_install_cert).click();
}

function onExportCertificate() {
    function DownloadCert(filename, text) {
        var element = document.createElement('a');
        element.setAttribute('href', 'data:application/pkix-cert;charset=utf-8,' + encodeURIComponent(text));
        element.setAttribute('download', filename);
        element.style.display = 'none';
        document.body.appendChild(element);
        element.click();
        document.body.removeChild(element);
    }
    cadesplugin.async_spawn(function* (args) {
        try {
            var oCert = global_selectbox_container[g_selected_cert_index];
            var subject = new CertificateAdjuster().GetCertName(yield oCert.SubjectName);
            var b64cert = yield oCert.Export(cadesplugin.CADESCOM_ENCODE_BASE64);
            DownloadCert(subject + ".cer", b64cert);
        }
        catch (err) {
            showErrorMsg(err);
        }
    });
}

function onDeleteContainer() {
    var s = document.getElementById(idContListBox)
    if (s) {
        var selectIndex = s.selectedIndex;
        cadesplugin.async_spawn(function* (args) {
            try {
                var oCont = g_conts[selectIndex];
                var fqcn = yield oCont.FQCN;
                if (confirm("Вы действительно хотите удалить данный контейнер?\n" +
                    "FQCN: " + fqcn + "\n\n" +
                    "Внимание! В результате этого действия контейнер будет безвозвратно удален!")) {
                    yield oCont.Delete();
                };
                refreshLists({ cont: true });
            }
            catch (err) {
                showErrorMsg(err);
            }
        });
    }
}

function onInstallCertFromContainer() {
    var s = document.getElementById(idContListBox)
    if (s) {
        var selectIndex = s.selectedIndex;
        cadesplugin.async_spawn(function* (args) {
            var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
            var oStoreToClose = false;
            try {
                var cont = g_conts[selectIndex];
                var fqcn = yield cont.FQCN;
                var keys = yield cont.Keys;
                var countKeys = yield keys.Count;
                for (j = 0; j < countKeys; j++) {
                    var key = yield keys.ItemByIndex(j);
                    var HasCert = yield key.HasCertificate;
                    if (HasCert) {
                        var oCert = yield key.Certificate;
                        var Subject = yield oCert.SubjectName;
                        var Issuer = yield oCert.IssuerName;
                        if (Subject == Issuer) {
                            yield oStore.Open(cadesplugin.CAPICOM_CURRENT_USER_STORE, "Root", cadesplugin.CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED);
                            oStoreToClose = true;
                            yield oStore.Add(oCert);
                        }
                        else {
                            var b64cert = yield oCert.Export(cadesplugin.CADESCOM_ENCODE_BASE64);
                            var Enroll = yield cadesplugin.CreateObjectAsync("X509Enrollment.CX509Enrollment");
                            yield Enroll.Initialize(cadesplugin.ContextUser);
                            yield Enroll.InstallResponse(
                                cadesplugin.CADESCOM_UseContainerStore |
                                cadesplugin.CADESCOM_AllowUntrustedRoot,
                                b64cert, cadesplugin.XCN_CRYPT_STRING_BASE64_ANY, "");
                        }
                    }
                    showInfoMsg("Сертификат из контейнера установлен\n" +
                        "FQCN: " + fqcn + "\n");
                    refreshLists();
                }
            }
            catch (err) {
                showErrorMsg(err);
            }
            if (oStoreToClose)
                yield oStore.Close();
        });
    }
}

function onDeleteCertificate() {
    var selectIndex = g_selected_cert_index;
    cadesplugin.async_spawn(function* (args) {
        var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
        var oStoreToClose = false;
        try {
            var oCert = global_selectbox_container[selectIndex];
            var Thumbprint = yield oCert.Thumbprint;
            var Subject = yield oCert.SubjectName;
            yield oStore.Open(storeLocation, storeName, cadesplugin.CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED);
            oStoreToClose = true;
            var oCerts = yield oStore.Certificates;
            oCerts = yield oCerts.Find(cadesplugin.CAPICOM_CERTIFICATE_FIND_SHA1_HASH, Thumbprint);
            var cnt = yield oCerts.Count;
            if (cnt < 1)
                showErrorMsg("Failed to delete certificate: " + Thumbprint + ".\nFound certificates: " + cnt);
            var oCertToDelete = yield oCerts.Item(1);
            var CertInfo = "Subject: " + Subject + "\n" + "Thumprint: " + Thumbprint + "\n";
            if (confirm("Вы уверены, что хотите удалить сертификат?\n" + CertInfo)) {
                yield oStore.Remove(oCertToDelete);
                refreshLists({ cert: true });
                toggleCertInfo();
            }
        }
        catch (err) {
            showErrorMsg(err);
        }
        if (oStoreToClose)
            yield oStore.Close();
    });
}

function onArchiveCertificate() {
    var selectIndex = g_selected_cert_index;
    cadesplugin.async_spawn(function* (args) {
        var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
        var oStoreToClose = false;
        try {
            var oCert = global_selectbox_container[selectIndex];
            var Thumbprint = yield oCert.Thumbprint;
            var Subject = yield oCert.SubjectName;
            yield oStore.Open(storeLocation, storeName, cadesplugin.CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED);
            oStoreToClose = true;
            var oCerts = yield oStore.Certificates;
            oCerts = yield oCerts.Find(cadesplugin.CAPICOM_CERTIFICATE_FIND_SHA1_HASH, Thumbprint);
            var cnt = yield oCerts.Count;
            if (cnt < 1)
                showErrorMsg("Failed to delete certificate: " + Thumbprint + ".\nFound certificates: " + cnt);
            var oCertToArchive = yield oCerts.Item(1);
            var isArchived = yield oCertToArchive.Archived;
            var CertInfo = "Subject: " + Subject + "\n" + "Thumprint: " + Thumbprint + "\n" + "Archived: " + isArchived + "\n";
            if (confirm("Вы уверены, что хотите отправить сертификат в архив?\n" + CertInfo)) {
                yield oCertToArchive.propset_Archived(true);
                var isArchived = yield oCertToArchive.Archived;
                var CertInfo = "Subject: " + Subject + "\n" + "Thumprint: " + Thumbprint + "\n" + "Archived: " + isArchived + "\n";
                alert(CertInfo);
                refreshLists({ cert: true });
                toggleCertInfo();
            }
        }
        catch (err) {
            showErrorMsg(err);
        }
        if (oStoreToClose)
            yield oStore.Close();
    });
}

var funcImportPfx = function (event) {
    var input = event.target;
    input.onclick = function () {
        this.value = null;
    };
    var reader = new FileReader();
    reader.readAsDataURL(input.files[0]);
    reader.onload = function () {
        var header = ";base64,";
        var fileData = reader.result;
        openFileContent = fileData.substr(fileData.indexOf(header) + header.length);
        cadesplugin.async_spawn(function* (args) {
            try {
                var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
                try {
                    yield oStore.ImportPFX(openFileContent);
                    var oCertificates = yield oStore.Certificates
                    var cCount = yield oCertificates.Count;
                    for (var i = 1; i <= cCount; i++) {
                        var oCert = yield oCertificates.Item(i);
                        InstallSingleCert(oCert);
                    }
                    yield oStore.Close();
                    openFileContent = null;
                    refreshLists();
                }
                catch (err) {
                    if (cadesplugin.getLastError(err).indexOf("0x80070056") !== -1) {
                        showPinPopUp();
                    }
                    else showErrorMsg(err);
                }
            }
            catch (err) {
                showErrorMsg(err);
            }
        });
    };
};

function InstallCertsFromStore(oStore) {
    cadesplugin.async_spawn(function* (args) {
        var oStore = args[0];
        var oCerts = yield oStore.Certificates;
        var nCerts = yield oCerts.Count;
        for (var i = 1; i <= nCerts; i++) {
            var oStoreCert = yield oCerts.Item(i);
            try {
                yield InstallSingleCert(oStoreCert);
            }
            catch (err) {
                // На данный момент не умеем импортировать сертификаты промежуточных УЦ
                console.log("Failed to import certificate" + (yield oStoreCert.SubjectName));
            }
        }
    }, oStore);
}

function InstallSingleCert(oCert, callback, isCA) {
    cadesplugin.async_spawn(function* (args) {
        showLoaderAnimation();
        var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
        var oStoreToClose = false;
        try {
            var oCert = args[0];
            var Subject = yield oCert.SubjectName;
            var Issuer = yield oCert.IssuerName;
            var Thumbprint = yield oCert.Thumbprint;
            try {
                var role = yield oCert.GetInfo(cadesplugin.CADESCOM_CERT_INFO_ROLE);
                isCA = isCA || (role == cadesplugin.CADESCOM_ROLE_CA);
            }
            catch (err) { };
            if (Subject == Issuer) {
                yield oStore.Open(cadesplugin.CAPICOM_CURRENT_USER_STORE, "Root", cadesplugin.CAPICOM_STORE_OPEN_READ_WRITE);
                oStoreToClose = true;
                yield oStore.Add(oCert);
                showInfoMsg("Сертификат Установлен\n" +
                    "Subject: " + Subject + "\n" +
                    "Thumprint: " + Thumbprint + "\n");
            }
            else if (isCA) {
                yield oStore.Open(cadesplugin.CAPICOM_CURRENT_USER_STORE, "CA", cadesplugin.CAPICOM_STORE_OPEN_READ_WRITE);
                oStoreToClose = true;
                try {
                    yield oStore.Add(oCert);
                    showInfoMsg("Сертификат Установлен\n" +
                        "Subject: " + Subject + "\n" +
                        "Thumprint: " + Thumbprint + "\n");
                }
                catch (err) {
                    if (cadesplugin.getLastError(err).indexOf("0x80070057") !== -1) {
                        showErrorMsg("Для установки сертификатов промежуточных УЦ требуется версия плагина не ниже 2.0.15300");
                    }
                    else showErrorMsg(err);
                }
            }
            else {
                var b64cert = yield oCert.Export(cadesplugin.CADESCOM_ENCODE_BASE64);
                var Enroll = yield cadesplugin.CreateObjectAsync("X509Enrollment.CX509Enrollment");
                yield Enroll.Initialize(cadesplugin.ContextUser);
                yield Enroll.InstallResponse(
                    cadesplugin.CADESCOM_UseContainerStore |
                    cadesplugin.CADESCOM_AllowUntrustedRoot,
                    b64cert, cadesplugin.XCN_CRYPT_STRING_BASE64_ANY, "");
                    showInfoMsg("Сертификат Установлен\n" +
                        "Subject: " + Subject + "\n" +
                        "Thumprint: " + Thumbprint + "\n");
            }
        }
        catch (err) {
            showErrorMsg(err);
        }
        if (oStoreToClose)
            yield oStore.Close();
        hideLoaderAnimation();
        if (callback)
            callback();
    }, oCert);
}

var funcInstallCert = function (event) {
    var input = event.target;
    input.onclick = function () {
        this.value = null;
    };
    var reader = new FileReader();
    reader.readAsDataURL(input.files[0]);
    reader.onload = function () {
        var header = ";base64,";
        var fileData = reader.result;
        openFileContent = fileData.substr(fileData.indexOf(header) + header.length);
        cadesplugin.async_spawn(function* (args) {
            var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
            var oStoreToClose = false;
            try {
                var oCert = yield cadesplugin.CreateObjectAsync("CAdESCOM.Certificate");
                yield oStore.Open(cadesplugin.CADESCOM_MEMORY_STORE, "", cadesplugin.CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED);
                oStoreToClose = true;
                try {
                    yield oCert.Import(openFileContent);
                    InstallSingleCert(oCert);
                    refreshLists({ cert: true });
                }
                catch (err) {
                    try {
                        // Пробуем импортировать как хранилище
                        yield oStore.Import(openFileContent);
                        yield InstallCertsFromStore(oStore);
                        refreshLists({ cert: true });
                    }
                    catch (err) {
                        // Если сохранен в base64
                        openFileContent = atob(openFileContent)
                        try {
                            yield oCert.Import(openFileContent);
                            yield InstallSingleCert(oCert);
                            refreshLists({ cert: true });
                        }
                        catch (err) {
                            try {
                                yield oStore.Import(openFileContent);
                                yield InstallCertsFromStore(oStore);
                                refreshLists({ cert: true });
                            }
                            catch (e) {
                                // Store.Import поддерживается только в новых версиях
                                // Выбросим более раннюю ошибку
                                throw err;
                            };
                        }
                    }
                }
            }
            catch (err) {
                showErrorMsg(err);
            }
            if (oStoreToClose)
                yield oStore.Close();
        });
    };
};

var storeLocation;
var storeName;
function FillContList_Async(lstId, loaderId) {
    resetGlobalContList();
    showLoaderAnimation();
    var lst = document.getElementById(lstId);
    lst.onchange = onContainerSelected;
    lst.boxId = lstId;
    cadesplugin.async_spawn(function* () {
        try {
            var oAbout = yield cadesplugin.CreateObjectAsync("CAdESCOM.about");
            var provType = 80;
            var CSPName = yield oAbout.CSPName(provType);
            var oCspInformation = yield cadesplugin.CreateObjectAsync("X509Enrollment.CCspInformation");
            yield oCspInformation.InitializeFromName(CSPName);

            oConts = yield oCspInformation.EnumContainers();
            var count = yield oConts.Count;
            for (i = 0; i < count; i++) {
                var cont = yield oConts.ItemByIndex(i);
                var fqcn = yield cont.FQCN;
                var unique = yield cont.UniqueName;
                var oOpt = document.createElement("OPTION");
                oOpt.text = fqcn;
                oOpt.value = g_conts_counter;
                lst.options.add(oOpt);
                var oLi = document.createElement("LI");
                var tnode = document.createTextNode(" " + fqcn);
                oLi.appendChild(tnode);
                oLi.value = g_conts_counter;
                oLi.nonce = unique;
                oLi.onclick = onSelectLiContainer;
                var UlContainer = document.getElementById(idUlContainer);
                UlContainer.appendChild(oLi);
                g_conts.push(cont);
                g_conts_counter++;
            }
        } catch (err) {
            if (cadesplugin.getLastError(err).indexOf("0x80070103") !== -1) {
                document.getElementById(idBoxNoCont).style.display = 'flex';
            }
            else
                showErrorMsg(err);
        }
        cont_loading_over = true;
        hideLoaderAnimation();
        toggleNoContMessage();
    });
}

var basicCertificatesFilled = false;
function fillBasicCertificates_Async(forceRefresh) {
    if (basicCertificatesFilled && !forceRefresh)
        return;
    cadesplugin.async_spawn(function* () {
        try {
            var divBasicCertificatesList = document.getElementById("divBasicCertificatesList");
            divBasicCertificatesList.innerHTML = "";
            showLoaderAnimation();
            cadesplugin.async_spawn(function* () {
                try {
                    var storeLocations = ["ROOT", "CA"];
                    for (var k = 0; k < storeLocations.length; k++) {
                        var Location = storeLocations[k];
                        var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
                        yield oStore.Open(cadesplugin.CAPICOM_CURRENT_USER_STORE, Location, cadesplugin.CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED);
                        var oCertificates = yield oStore.Certificates;
                        var basic_certificates = Location == "ROOT" ? basic_certificates_root : basic_certificates_ca;
                        for (var i = 0; i < basic_certificates.length; i++) {
                            var oCert = yield cadesplugin.CreateObjectAsync("CAdESCOM.Certificate");
                            yield oCert.Import(basic_certificates[i]);
                            var Thumbprint = yield oCert.Thumbprint;
                            var Count = 0;
                            try {
                                var oTempCerts = yield oCertificates.Find(cadesplugin.CAPICOM_CERTIFICATE_FIND_SHA1_HASH, Thumbprint);
                                var Count = yield oTempCerts.Count;
                            } catch (err) { }

                            var adjust = new CertificateAdjuster();
                            var ValidFromDate = new Date((yield oCert.ValidFromDate));
                            var Subject = adjust.GetCertInfoString(yield oCert.SubjectName, ValidFromDate);
                            var divGrid82 = document.createElement("div");
                            divGrid82.className = "grid2hor82";
                            var li = document.createElement("li");
                            li.className = "border-ellipse";
                            var tnode = document.createTextNode(Subject);
                            li.appendChild(tnode);
                            divGrid82.appendChild(li);
                            var Btn = document.createElement("button");
                            Btn.className = "button-installbasiccert";
                            if (Count > 0) {
                                Btn.innerText = "Установлен";
                                Btn.style.background = "#D0FED0";
                            } else {
                                Btn.innerText = "Установить";
                                Btn.oCert = oCert;
                                Btn.isCA = Location == "CA";
                                Btn.addEventListener("click", function () {
                                    InstallSingleCert(
                                        this.oCert,
                                        function () { refreshLists({ basiccert: true }) },
                                        this.isCA);
                                });
                            }
                            divGrid82.appendChild(Btn);
                            divBasicCertificatesList.appendChild(divGrid82);
                        }
                        yield oStore.Close();
                        basicCertificatesFilled = true;
                    }
                } catch (err) {
                    showErrorMsg(err);
                }
                hideLoaderAnimation();
            });
        } catch (err) {
            showErrorMsg(err);
        }
    });
}

function FillCertListFromStore_Async(lstId, loaderId) {
    cadesplugin.async_spawn(function* () {
        var enumGuid = uuidv4();
        g_certenum_guid = enumGuid;
        resetGlobalCertList();
        toggleCertInfo();
        showLoaderAnimation();
        var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
        var oStoreToClose = false;
        try {
            var show_archived = false;
            var chkShowArchived = document.getElementById(idCheckShowArchived);
            if (chkShowArchived)
                show_archived = chkShowArchived.checked;
            var show_expired = false;
            var chkShowExpired = document.getElementById(idCheckShowExpired);
            if (chkShowExpired)
                show_expired = chkShowExpired.checked;
            cert_loading_over = false;
            storeLocation = parseInt(elemStoreLoc.value);
            storeName = elemStoreName.value;
            yield oStore.Open(storeLocation, storeName, cadesplugin.CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED | cadesplugin.CAPICOM_STORE_OPEN_INCLUDE_ARCHIVED);
            oStoreToClose = true;
            var certs = yield oStore.Certificates;
            var certCnt = yield certs.Count;
            for (var i = 1; i <= certCnt; i++) {
                var cert = yield certs.Item(i);
                var thumbprint = yield cert.Thumbprint;
                var oOpt = document.createElement("OPTION");
                var ValidFromDate = new Date((yield cert.ValidFromDate));
                var ValidToDate = new Date(yield cert.ValidToDate);
                var IsValid = ValidToDate > Date.now();
                var emoji = CertStatusEmoji(IsValid);
                oOpt.text = emoji + new CertificateAdjuster().GetCertInfoString(yield cert.SubjectName, ValidFromDate);
                oOpt.value = global_selectbox_counter;

                var oLi = document.createElement("LI");
                oLi.appendChild(document.createTextNode(emoji + new CertificateAdjuster().GetCertInfoString(yield cert.SubjectName, ValidFromDate)));
                oLi.value = global_selectbox_counter;
                oLi.nonce = thumbprint;
                oLi.onclick = onSelectLiCertificate;
                oLi.setAttribute(filteredOutAttribute, 0);
                try {
                    isArchived = yield cert.Archived;
                    if (isArchived) {
                        oLi.setAttribute(archivedAttribute, true);
                        if (!show_archived) {
                            oLi.setAttribute(filteredOutAttribute, parseInt(oLi.getAttribute(filteredOutAttribute)) + 1);
                            oLi.style.display = "none";
                        }
                    }
                }
                catch (err) { }
                if (new Date() > ValidToDate) {
                    oLi.setAttribute(expiredAttribute, true);
                    if (!show_expired) {
                        oLi.setAttribute(filteredOutAttribute, parseInt(oLi.getAttribute(filteredOutAttribute)) + 1);
                        oLi.style.display = "none";
                    }
                }

                // CADES-2699: Если пользователь выбрал другое хранилище, заканчиваем перечисление
                if (enumGuid != g_certenum_guid)
                    break;

                document.getElementById(idUlCertificate).appendChild(oLi);
                global_selectbox_container.push(cert);
                if (storeLocation == cadesplugin.CADESCOM_CONTAINER_STORE ||
                    storeLocation == cadesplugin.CADESCOM_SMART_CARD_USER_STORE)
                    global_isFromCont.push(true);
                global_selectbox_counter++;
            }
        } catch (err) {
            showErrorMsg(err);
        }
        if (oStoreToClose)
            yield oStore.Close();
        cert_loading_over = true;
        hideLoaderAnimation();
        if (enumGuid == g_certenum_guid)
            toggleNoCertMessage();
    });
}

function onChkShowFeatured(idParent, idChkBox, attributeName) {
    var parent = document.getElementById(idParent);
    var show_featured = false;
    var chkShowFeatured = document.getElementById(idChkBox);
    if (chkShowFeatured)
        show_featured = chkShowFeatured.checked;
    var children = parent.children;
    for (var i = 0; i < children.length; i++) {
        var oLi = children[i];
        if (oLi.getAttribute(attributeName) !== 'true')
            continue;
        if (show_featured) {
            var filterLevel = parseInt(oLi.getAttribute(filteredOutAttribute));
            if (filterLevel > 0)
                oLi.setAttribute(filteredOutAttribute, filterLevel - 1);
            if (parseInt(oLi.getAttribute(filteredOutAttribute)) == 0)
                oLi.style.display = "";
        }
        else { 
            oLi.setAttribute(filteredOutAttribute, parseInt(oLi.getAttribute(filteredOutAttribute)) + 1);
            oLi.style.display = "none";
        }
    }
    resetSearchBar(idSearchBarCertificate);
    updateSearchBar(idSearchBarCertificate, idUlCertificate);
}

function resetSearchBar(idSearchBar) {
    input = document.getElementById(idSearchBar);
    input.value = "";
}

function resetUL(idUl) {
    ul = document.getElementById(idUl);
    ul.innerHTML = "";
}

function highlightSelectedLi(idUl, oLi) {
    ul = document.getElementById(idUl);
    li = ul.getElementsByTagName('li');
    for (i = 0; i < li.length; i++) {
        if (parseInt(li[i].getAttribute(filteredOutAttribute)) > 0)
            continue;
        li[i].style = "background-color: white";
        li[i].style = "color: black";
    }
    oLi.style.color = "white";
    oLi.style.backgroundColor = "blue";
}

function onSelectLiContainer(event) {
    var isSearchOff = document.getElementById(idSearchBarContainer).value == "";
    resetSearchBar(idSearchBarContainer);
    var selectedLi = event.target;
    idUl = idUlContainer;
    highlightSelectedLi(idUl, selectedLi);

    if (!isSearchOff) {
        var ul = document.getElementById(idUl);
        ul.scrollTop = selectedLi.offsetTop;
    }
    var clb = document.getElementById(idContListBox);
    clb.selectedIndex = selectedLi.value;
    const event2 = new Event('change', {
        bubbles: true,
        cancelable: true
    });
    clb.dispatchEvent(event2);
}

function onSelectLiCertificate(event) {
    var isSearchOff = document.getElementById(idSearchBarCertificate).value == "";
    resetSearchBar(idSearchBarCertificate);
    var selectedLi = event.target;
    idUl = idUlCertificate;
    highlightSelectedLi(idUl, selectedLi);

    if (!isSearchOff) {
        var ul = document.getElementById(idUl);
        ul.scrollTop = selectedLi.offsetTop;
    }
    
    g_selected_cert_index = selectedLi.value;
    var oCert = global_selectbox_container[g_selected_cert_index];
    FillCertInfo_Async(oCert);
    FillCertChainInfo_Async(oCert);
    toggleCertButtons();
}

function onContainerSelected(event) {
    cadesplugin.async_spawn(function *(args) {
        var selectedCertID = args[0][args[0].selectedIndex].value;
        var container = g_conts[selectedCertID];
        FillContInfo_Async(container, event.target.boxId);
    }, event.target);
    toggleContButtons();
}

function clearContInfo() {
    document.getElementById("name").innerHTML = "Name: ";
    document.getElementById("uniqueName").innerHTML = "Unique: ";
    document.getElementById("media").innerHTML = "Media: ";
    document.getElementById("reader").innerHTML = "Reader: ";
    document.getElementById("fqcn").innerHTML = "FQCN: ";
    document.getElementById("countKeys").innerHTML = "Ключей: ";
    document.getElementById("additionalContInfo").innerHTML = "";
}

function makeBold(input) {
    return "<b>" + input + "</b>";
}

function FillContInfo_Async(container) {
    clearContInfo();
    showLoaderAnimation();
    var cont = container;
    cadesplugin.async_spawn(function* (args) {
        try {
            var name = yield cont.Name;
            var uniqueName = yield cont.UniqueName;
            var media = yield cont.Media;
            var reader = yield cont.Reader;
            var fqcn = yield cont.FQCN;
            var keys = yield cont.Keys;
            var countKeys = yield keys.Count;
            document.getElementById("name").innerHTML += makeBold(name);
            document.getElementById("uniqueName").innerHTML += makeBold(uniqueName);
            document.getElementById("media").innerHTML += makeBold(media);
            document.getElementById("reader").innerHTML += makeBold(reader);
            document.getElementById("fqcn").innerHTML += makeBold(fqcn);
            document.getElementById("countKeys").innerHTML += makeBold(countKeys);

            isCertInCont = false;
            for (j = 0; j < countKeys; j++) {
                try {
                    var key = yield keys.ItemByIndex(j);
                    var isExportable = yield key.IsExportable;
                    var KeyType = yield key.Type;
                    var HasCert = yield key.HasCertificate;
                    var ExpTime = yield key.ExpirationTime;
                    var oPublicKey = yield key.PublicKey;
                    var keyLength = yield oPublicKey.Length;
                    var oAlgorithm = yield oPublicKey.Algorithm;
                    var fAlgoName = yield oAlgorithm.FriendlyName;
                    var KP_FP = yield key.KP_FP;

                    var sKeyType = "";
                    if (KeyType == cadesplugin.AT_KEYEXCHANGE) sKeyType = "AT_KEYEXCHANGE";
                    if (KeyType == cadesplugin.AT_SIGNATURE) sKeyType = "AT_SIGNATURE";
                    document.getElementById("additionalContInfo").innerHTML += "Тип ключа:               " + makeBold(sKeyType) + "<br>";
                    document.getElementById("additionalContInfo").innerHTML += "Экспорт ключа:           " + makeBold(isExportable) + "<br>";
                    document.getElementById("additionalContInfo").innerHTML += "Ключ действителен до:    " + makeBold(ExpTime) + "<br>";
                    document.getElementById("additionalContInfo").innerHTML += "Алгоритм ключа:          " + makeBold(fAlgoName) + "<br>";
                    document.getElementById("additionalContInfo").innerHTML += "Длина ключа:             " + makeBold(keyLength) + "<br>";
                    document.getElementById("additionalContInfo").innerHTML += "KP_FP:                   " + makeBold(KP_FP) + "<br>";
                    document.getElementById("additionalContInfo").innerHTML += "Сертификат в контейнере: " + makeBold(HasCert) + "<br>";

                    if (HasCert) {
                        isCertInCont = true;
                        var Adjust = new CertificateAdjuster();
                        var oCertificate = yield key.Certificate;
                        var serial = yield oCertificate.SerialNumber;
                        var subject = escapeHtml(Adjust.GetCertName(yield oCertificate.SubjectName));
                        var issuer = escapeHtml(Adjust.GetIssuer(yield oCertificate.IssuerName));
                        var validFrom = escapeHtml(Adjust.GetCertDate(yield oCertificate.ValidFromDate)) + " UTC";
                        var validTo = escapeHtml(Adjust.GetCertDate(yield oCertificate.ValidToDate)) + " UTC";
                        var thumbprint = yield oCertificate.Thumbprint;
                        var oPublicKey = yield oCertificate.PublicKey();
                        var keyLength = yield oPublicKey.Length;
                        var oAlgorithm = yield oPublicKey.Algorithm;
                        var fAlgoName = yield oAlgorithm.FriendlyName;
                        document.getElementById("additionalContInfo").innerHTML += "";
                        document.getElementById("additionalContInfo").innerHTML += "Владелец:        " + makeBold(subject) + "<br>";
                        document.getElementById("additionalContInfo").innerHTML += "Издатель:        " + makeBold(issuer) + "<br>";
                        document.getElementById("additionalContInfo").innerHTML += "Серийный номер:  " + makeBold(serial) + "<br>";
                        document.getElementById("additionalContInfo").innerHTML += "Действителен с:  " + makeBold(validFrom) + "<br>";
                        document.getElementById("additionalContInfo").innerHTML += "Действителен до: " + makeBold(validTo) + "<br>";
                        document.getElementById("additionalContInfo").innerHTML += "Отпечаток:       " + makeBold(thumbprint) + "<br>";
                        document.getElementById("additionalContInfo").innerHTML += "Алгоритм ключа:  " + makeBold(fAlgoName) + "<br>";
                        document.getElementById("additionalContInfo").innerHTML += "Длина ключа:     " + makeBold(keyLength) + "<br>";
                    }
                }
                catch (err) {
                    showErrorMsg(err);
                }
            }
        }
        catch (err) {
            showErrorMsg(err);
        }
        toggleContInfo();
        toggleContButtons();
        hideLoaderAnimation();
    });
}

function FillCertChainInfo_Async(oCert) {
    cadesplugin.async_spawn(function* (args) {
        try {
            showLoaderAnimation();
            var Validator = yield args[0].IsValid();
            var isValidInfo = "";
            var oChainCerts = yield Validator.ValidationCertificates;
            var chainCount = yield oChainCerts.Count;
            for (var j = 1; j <= chainCount; j++) {
                var Adjust = new CertificateAdjuster();
                var oCertificate = yield oChainCerts.Item(j);
                var serial = yield oCertificate.SerialNumber;
                var subject = escapeHtml(Adjust.GetCertName(yield oCertificate.SubjectName));
                var issuer = escapeHtml(Adjust.GetIssuer(yield oCertificate.IssuerName));
                var validFrom = escapeHtml(Adjust.GetCertDate(yield oCertificate.ValidFromDate)) + " UTC";
                var validTo = escapeHtml(Adjust.GetCertDate(yield oCertificate.ValidToDate)) + " UTC";
                var thumbprint = yield oCertificate.Thumbprint;
                isValidInfo += "<br/>• ";
                if (subject == issuer) {
                    isValidInfo += "<b>Корневой сертификат</b>: <br/>";
                } else if (j != chainCount) {
                    isValidInfo += "<b>Промежуточный сертификат</b>: <br/>";
                } else {
                    isValidInfo += "<b>Конечный сертификат</b>: <br/>";
                }
                isValidInfo += "Владелец: <b>" + subject + "</b><br/>";
                isValidInfo += "Издатель: <b>" + issuer + "</b><br/>";
                isValidInfo += "Серийный номер: <b>" + serial + "</b><br/>";
                isValidInfo += "Действителен с: <b>" + validFrom + "</b><br/>";
                isValidInfo += "Действителен до: <b>" + validTo + "</b><br/>";
                isValidInfo += "Отпечаток: <b>" + thumbprint + "</b><br/>";
            }
            document.getElementById(idCertChain).innerHTML = isValidInfo;
        }
        catch (err) {
            showErrorMsg(err);
        }
        toggleCertInfo();
        hideLoaderAnimation();
    }, oCert);
}

function resetUIList(idListBox, idUl, idSearchBar) {
    document.getElementById(idListBox).selectedIndex = -1;
    resetUL(idUl);
    resetSearchBar(idSearchBar);
}

function refreshLists(param) {
    showLoaderAnimation();
    if (!param) {
        FillCertListFromStore_Async(idCertListBox);
        FillContList_Async(idContListBox);
    }
    else {
        if (param.cert) {
            FillCertListFromStore_Async(idCertListBox);
        }
        if (param.cont) {
            FillContList_Async(idContListBox);
        }
        if (param.basiccert) {
            fillBasicCertificates_Async(true);
        }
    }
    toggleContInfo();
    toggleCertInfo();
    toggleContButtons();
    toggleCertButtons();
    hideLoaderAnimation();
}

function updateSearchBar(idSearchBar, idUl) {
    var input, filter, ul, li, a, i, txtValue;
    input = document.getElementById(idSearchBar);
    filter = input.value.toUpperCase();
    ul = document.getElementById(idUl);
    li = ul.getElementsByTagName('li');

    for (i = 0; i < li.length; i++) {
        txtValue = li[i].innerText;
        thumbprint = li[i].nonce;
        if (parseInt(li[i].getAttribute(filteredOutAttribute)) > 0)
            continue;
        if (txtValue.toUpperCase().indexOf(filter) > -1 || thumbprint.toUpperCase().indexOf(filter) > -1) {
            li[i].style.display = "";
        } else {
            li[i].style.display = "none";
        }
    }
}

function hideAllDropdowns(skipId) {
    var dropdowns = document.getElementsByClassName("dropdown-content");
    for (var i = 0; i < dropdowns.length; i++) {
        var openDropdown = dropdowns[i];
        if (document.getElementById(skipId) == openDropdown)
            continue;
        openDropdown.classList.remove('show');
    }
}

function onDropdownValueSelected(element) {
    // TODO: сделать нормально
    var parentButton = element.parentNode.parentNode.children[0];
    var index = Array.prototype.indexOf.call(element.parentNode.children, element);
    var cs = document.getElementById(connectedSelect[element.parentNode.id]);
    cs.selectedIndex = index;
    const event2 = new Event('change', {
        bubbles: true,
        cancelable: true
    });
    cs.dispatchEvent(event2);
    parentButton.innerText = element.innerText;
}

function onDropdownClicked(id) {
    hideAllDropdowns(id);
    var dd = document.getElementById(id);
    dd.classList.toggle("show");
}

window.addEventListener("click", function (event) {
    if (!event.target.matches('.dropbtn')) {
        hideAllDropdowns();
    }
});

window.onkeyup = (e) => {
    var idSearchBar;
    var idUl;
    if (activeTabName == nameTabCertificates) {
        idSearchBar = idSearchBarCertificate;
        idUl = idUlCertificate;
    } else if (activeTabName == nameTabContainers) {
        idSearchBar = idSearchBarContainer;
        idUl = idUlContainer;
    } else {
        return;
    }
    if (e.key === 'Tab') {
        var searchBar = document.getElementById(idSearchBar);
        searchBar.value = searchBar.value;
        searchBar.focus();
    }
    if (e.key === 'Escape') {
        resetSearchBar(idSearchBar);
        updateSearchBar(idSearchBar, idUl);
        document.activeElement.blur();
    }
}

window.addEventListener("orientationchange", function() {
    document.activeElement.blur();
});

showGeneralInfoTab();
showContent();
